MAXScript Extensions > MAXScript Extensions for Particle Flow > Particle Flow Classes > Operators > Transforms >

# Spin : Helper

    Spin - superclass: helper super-superclass:node - classID: #(1962490634, 515064320)

Value > MAXWrapper > Node > Helper > Spin

| Particle Flow - Quick Navigation

Description:

The Spin operator gives an angular velocity to particles in an event, with optional random variation. Spin is applied once per event per particle, except when using the Speed Space Follow option; however, the settings can be animated.

Constructor:

    Spin...

Properties:

    <Spin>.SpinRate Float default:360.0 --angle

The rate of revolution in degrees per second.

    <Spin>.Variation Float default:0.0 --angle

The maximum amount, in degrees per second, by which the spin rate can vary. The actual variation is calculated once, at random, for each particle.

    <Spin>.Direction Integer default:0

Controls the state of the drop-down list in the UI. Lets you apply the spin on a random or specific axis, with optional random variation of the spin axis. Possible values are:

0: Random 3D - Spins each particle about an arbitrary, random 3D axis.

1: World Space - The spin axis is specified in the world coordinate space. Use the X/Y/Z settings to specify the spin axis.

2: Particle Space - The spin axis is specified in the local coordinate space of each particle. Use the X/Y/Z settings to specify the spin axis.

3: Speed Space - The coordinate space for particle orientation is determined by the particles' direction upon entering the event. The X axis is aligned with the particle direction, while the Z axis is perpendicular to the X axis and is pointed upward with respect to world space as much as possible. Use the X/Y/Z settings to specify the orientation for all particles.

4: Speed Space Follow - The coordinate space for particle orientation is determined by the particles' direction throughout the event. Use this option to allow particles that change direction during the event to keep the spin axis aligned with their direction. The X axis is aligned with the particle direction, while the Z axis is perpendicular to the X axis and is pointed upward with respect to world space as much as possible. Use the X/Y/Z settings to specify the orientation for all particles.

    <Spin>.Spin_X_Axis Float default:0.0
    <Spin>.Spin_Y_AxisFloat default:0.0
    <Spin>.Spin_Z_AxisFloat default:1.0

These values define the spin axis. Unavailable when .Direction is set to 0 : Random 3D. Range is from -1.0 to 1.0.

    <Spin>.Divergence Float default:0.0 --angle

Defines the range of variation (in degrees) for spin-axis orientation. The actual deviation is calculated at random within this range. Unavailable when .Direction is set to 0 : Random 3D. Range is from 0 to 180.

    <Spin>.Random_Seed Integer default:12345

Specifies a randomization value.

## Spin Interfaces:

Interface: action

Interface: operator

Interface: PViewItem

#### See Also

- Particle Flow Classes